/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef APPCONTROLLER_H_
#define APPCONTROLLER_H_

#include <MAUtil/Moblet.h>
#include <MAUtil/Map.h>
#include <MAUtil/Stack.h>
#include <MAUI/Screen.h>
#include <MAUI/Font.h>
#include "ScreenTransition.h"
#include "Utilities/ImageCache.h"
#include "Utilities/RSSDownloadQueue.h"

#define APPCONTROLLER AppController::getInstance()

using namespace MAUtil;
using namespace MAUI;

class AppController
{
	public:
		~AppController();

		static AppController* getInstance();

		Moblet* getMoblet();
		void setMoblet(Moblet* moblet);

		void registerScreen(String screenName, Screen* screen);
		int registerScreen(Screen* screen);

		void show(String screenName);
		void show(int screenIndex);

		Screen* getScreen(int screenIndex);
		Screen* getScreen(String screenName);

		void back();
		void close();

        void addFont(String name, Font* font);
        Font* getFont(String name);

        void addSkin(String name, WidgetSkin* skin);
        WidgetSkin* getSkin(String name);

        int getScreenWidth();
        int getScreenHeight();

        ImageCache* getImageCache();
        RSSDownloadQueue* getRSSDownloadQueue();

	protected:
		AppController();

	private:
		static AppController* mInstance;

		Moblet* mMoblet;

		HashMap<String, int> mIndex;
		Vector<Screen*> mScreens;
		Stack<int> mHistory;

		int getIndex(String& screenName);

	    HashMap<String, Font*> mFonts;
	    HashMap<String, WidgetSkin*> mSkins;

	    int mScrWidth;
	    int mScrHeight;

	    ImageCache* mImageCache;
	    RSSDownloadQueue* mRSSDownloadQueue;
};

#endif /* APPCONTROLLER_H_ */
