/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef MENUSCREEN_H_
#define MENUSCREEN_H_

#include <MAUI/Screen.h>
#include <MAUtil/Map.h>
#include "../Widgets/UIBuilder.h"
#include "../Widgets/GridMenu.h"
#include "../Utilities/JSONParser.h"

using namespace MAUI;
using namespace MAUtil;

//This is the menu.  It reads through the config.json file and creates the menu

class MenuScreen : public Screen,
				   public GridMenuListener,
				   public JSONListener
{
	public:
		MenuScreen();
		~MenuScreen();

		//GridMenuListener interface
		void GridMenuItemSelected(int item, Widget* selectedItem);

		//JSONListener interface
	    void header(String& header);
	    void data(String& value);
	    void arrayStart();
	    void arrayEnd();
	    void objectStart();
	    void objectEnd();

	private:
		Layout* mLayout;
		GridMenu* mGridMenu;

		Vector<String> mURLs;

		JSONParser* mParser;

		//State information to parse the json
		enum ConfigState
		{
			NAME,
			URL,
			LOGO
		} mConfigState;

		//Working instance of MenuButton
		MenuButton* mButton;
		int mObjectCounter;

		//Keep track of the RSSIndex screen required
		Map<int, int> mScreens;
};

#endif /* MENUSCREEN_H_ */
