/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef RSSINDEX_H_
#define RSSINDEX_H_
#include <MAUI/Screen.h>
#include <MAUI/Layout.h>
#include <MAUI/Label.h>
#include <MAUI/ListBox.h>
#include <MAUtil/Vector.h>

#include "../Utilities/RSS.h"
#include "../Utilities/RSSProcessor.h"
#include "../Utilities/XMLConnection.h"

#include "../Widgets/KineticListBox.h"
#include "../Widgets/RSSItemWidget.h"

using namespace MAUI;
using namespace MAUtil;

class RSSIndex : public Screen,
				 public RSSListener,
				 public KineticListBoxListener,
				 public WidgetListener
{
	public:
		RSSIndex();
		~RSSIndex();

		//KineticListBoxListener
        void itemSelected(KineticListBox *sender, Widget *selectedWidget, Widget *unselectedWidget);
        void blocked(KineticListBox *sender, int direction);

		//RSSListener
		void rssItemReceived(RSSItem& item);
		void rssChannelReceived(RSSChannel& channel);

		//Handle key presses
		void keyPressEvent(int keyCode, int nativeCode);

		//Tell the screen to get the RSS feed
		void getFeed(String& url);

		void triggered(Widget* sender);
	private:
		Layout* mLayout;
		KineticListBox* mItems;
		Label* mTitle;
		Label* mSoftkey;

		int mRSSScreenID;
};

#endif /* RSSINDEX_H_ */
