/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef RSSSCREEN_H_
#define RSSSCREEN_H_

#include <MAUI/Screen.h>
#include <MAUI/Image.h>
#include <MAUI/Layout.h>
#include <MAUI/Label.h>
#include <MAUI/ListBox.h>
#include "../Utilities/RSS.h"
#include "../Utilities/ImageCacheListener.h"

using namespace MAUI;

class RSSScreen : public Screen,
				  public ImageCacheListener
{
	public:
		RSSScreen();
		~RSSScreen();

		//ImageCacheListener
		void imageReady(MAHandle h);

		//Provide an interface to pass an RSSItem to this screen
		void setRSSItem(RSSItem* rssItem);

		//Capture key presses
		void keyPressEvent(int keyCode, int nativeCode);
	private:
		Layout* mLayout;
		Label* mTitle;
		Label* mSoftkey;
		ListBox* mContent;

		//Listbox content
		Image* mImage;
		Label* mText;
		Label* mLink;

		//Store the url
		String mUrl;
};

#endif /* RSSSCREEN_H_ */
