/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef JSONCONNECTION_H_
#define JSONCONNECTION_H_

#include <MAUtil/String.h>

using namespace MAUtil;

class JSONListener
{
  public:
    virtual void header(String& header) = 0;
    virtual void data(String& value) = 0;
    virtual void arrayStart() = 0;
    virtual void arrayEnd() = 0;
    virtual void objectStart() = 0;
    virtual void objectEnd() = 0;

};

class JSONParser
{
  public:
    JSONParser();
    ~JSONParser();

    void parseString(String& jsondata);

    void addListener(JSONListener* listener);

    void reset();
  private:
    String data;
    String temp;
    int _start;
    int _end;

    Vector<JSONListener*> _listeners;
    void parse();
    int findNextQuote(int startPos);
    int nextDelimiter(int startPos);
    int findPosition(char c, int startPos);

    void returnData(String& data);
    void returnHeader(String& header);
    bool readingString;
};
#endif /* JSONCONNECTION_H_ */
