/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef RSS_H_
#define RSS_H_

#include <MAUtil/String.h>
#include <matime.h>
using namespace MAUtil;

//Represents a singe RSS entry
struct RSSItem
{
  public:
    String title;
    String description;
    time_t date;
    String imageurl;
    String url;
};

//Represents information about a single RSS feed
struct RSSChannel
{
	String title;
	String description;
	String author;
	String copyright;
	String imageurl;
};

//Classes which wish to receive RSS data should implement this interface
class RSSListener
{
	public:
		virtual void rssItemReceived(RSSItem& item) = 0;
		virtual void rssChannelReceived(RSSChannel& channel) = 0;
};
#endif /* RSS_H_ */
