/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef RSSDOWNLOADQUEUE_H_
#define RSSDOWNLOADQUEUE_H_

#include <MTXml/MTXml.h>
#include <MAUtil/String.h>
#include <MAUtil/Environment.h>
#include "XmlConnection.h"
#include "RSSProcessor.h"
#include "RSS.h"
#include "Queue.h"

using namespace MAUtil;
using namespace Mtx;

struct RSSDownloadRequest
{
	//The url of the feed to listen to
	String url;

	//The requesting object.  This needs implement RSSListener
	RSSListener* requester;
};

//Classes requiring an RSS feed can ask the queue to get it for them by completing a
//request
class RSSDownloadQueue : public RSSProcessorListener
{
	public:
		RSSDownloadQueue();
		~RSSDownloadQueue();

		void processQueue();

		//RSSProcessorListener
		void processingComplete();

		void addRequest(String& url, RSSListener* requester);
		void addRequest(RSSDownloadRequest* req);

	private:
		Queue<RSSDownloadRequest> mRequests;
		XmlConnection* mConn;
		RSSProcessor* mProcessor;
		RSSDownloadRequest* mNextRequest;
};

#endif /* RSSDOWNLOADQUEUE_H_ */
