/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef RSSITEMWIDGET_H_
#define RSSITEMWIDGET_H_
#include <MAUI/Label.h>
#include <MAUI/Image.h>
#include <MAUtil/Environment.h>
#include "../Utilities/ImageCacheListener.h"

using namespace MAUI;
using namespace MAUtil;

class RSSItemWidget : public Widget,
					  public PointerListener
{
	public:
		RSSItemWidget(int x, int y, int height, int width, Widget* parent);
		~RSSItemWidget();

		void setTitleFont(Font* font);
		void setTextFont(Font* font);

		void setTitle(String& title);
		void setText(String& text);
		void setImageUrl(String& url);
		void setUrl(String& url);

		const String& getTitle();
		const String& getText();
		String& getImageUrl();
		String& getUrl();

		void setNextImage(MAHandle nextImage);

		//PointerListener
		void pointerPressEvent(MAPoint2d p);
		void pointerMoveEvent(MAPoint2d p);
		void pointerReleaseEvent(MAPoint2d p);

		void setSelected(bool selected = true);

		//Widget requirement
		void drawWidget();

	private:
		Label* mTitle;
		Label* mText;
		Image* mImage;
		Image* mNextImage;

		String mImageUrl;
		String mUrl;
		bool mListening;
};

#endif /* RSSITEMWIDGET_H_ */
