/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#include "UIBuilder.h"
#include "MAHeaders.h"
#include "../std.h"
#include "Colours.h"

void setSKPadding(Widget* w) 
{
	w->setPaddingLeft(HORIZONTALPADDING);
	w->setPaddingBottom(4);
	w->setPaddingRight(HORIZONTALPADDING);
	w->setPaddingTop(3);
}

void setLabelPadding(Widget* w) 
{
	w->setPaddingLeft(HORIZONTALPADDING);
	w->setPaddingBottom(VERTICALPADDING);
	w->setPaddingRight(HORIZONTALPADDING);
	w->setPaddingTop(VERTICALPADDING);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Create a new label widget with the plain skin
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Label* createLabel(const char* str, int height) 
{
	////lprintfln("Creating label: Text is %s, height is %d", str, height);
	Label* label;
	label = new Label(0,0, APPCONTROLLER->getScreenWidth(), height, NULL, str, 0, APPCONTROLLER->getFont("default"));

	label->setBackgroundColor(WHITE);
	label->setHorizontalAlignment(Label::HA_LEFT);
	label->setMultiLine(true);

	setLabelPadding(label);
	label->setAutoSizeY(true);
	label->setAutoSizeX(false);
	return label;
}

Label* createLabel(String& str, int height)
{
  return createLabel(str.c_str(), height);
}

// Create a new image widget
Image* createImage(int res)
{
	////lprintfln("Creating image");
	Image* i = new Image(0, 0, APPCONTROLLER->getScreenWidth(), APPCONTROLLER->getScreenHeight(), NULL, true, true, res);
	i->setDrawBackground(false);
	return i;
}


// Create a new menu image  widget
Widget* createMenuImage(int res, char* caption, Font* f, WidgetSkin* skin)
{
	MenuButton* mb = new MenuButton(0, 0, 74, 94, NULL, res, OVERLAY, HIGHLIGHT, caption);
	//Don't show the label in this version
	//MenuButton* mb = new MenuButton(0, 0, 74, 74, NULL, res, OVERLAY, HIGHLIGHT, "");
	mb->setSkin(skin);
	mb->setFont(f);
	return mb;
}


