/* Copyright (C) 2010 MoSync AB

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License, version 2, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#include <MAUtil/Moblet.h>
#include <MAUI/Font.h>
#include <MAUI/WidgetSkin.h>
#include "std.h"
#include "AppLoader.h"
#include "MAHeaders.h"
#include <MAUI/Engine.h>

using namespace MAUtil;
using namespace MAUI;

class StarterMoblet :  public Moblet
{
	public:
	StarterMoblet()
		{
			//Create a new font, and give it to the AppController to look after it.
		    APPCONTROLLER->addFont("default", new Font(RES_FONT));
		    APPCONTROLLER->addFont("title", new Font(TITLE_FONT));
		    APPCONTROLLER->addFont("itemfont", new Font(ITEM_FONT));
    		//The font can be retrieved from the AppController by name
    		Engine::getSingleton().setDefaultFont(APPCONTROLLER->getFont("default"));

    		//Create a new skin, and give it to the AppController to look after it
    		APPCONTROLLER->addSkin("title", new WidgetSkin(TITLE_SKIN, TITLE_SKIN, 11, 27, 22, 74, false, false));
    		APPCONTROLLER->addSkin("rssitem", new WidgetSkin(RSS_SKIN, RSS_SKIN, 2, 62, 2, 62, false, false));
    		//The AppController needs a pointer to the moblet
			APPCONTROLLER->setMoblet(this);

			//Load the screens - no knowledge of screens required at buildtime
			AppLoader* loader = new AppLoader();
			loader->load();
			delete loader;

			//Show the first screen.  This was loaded in AppLoader
			APPCONTROLLER->show("MenuScreen");
		}

		~StarterMoblet()
		{
			delete APPCONTROLLER;
		}

	private:
};

extern "C" int MAMain()
{
	Moblet::run(new StarterMoblet());
	return 0;
};
